#include<stdio.h>
#include<string.h>
#include<stdlib.h>

typedef struct _red{
  char* r; //redak
  struct _red* next;
}red;

void invertiraj(FILE *in, FILE *out)
{
  char sep, rijec[32], *redak=malloc(sizeof(char));
  char sepstr[]=" "; /*sepstr je string konstantne duljine (1+1 za '\0'), a u njega
                      cemo spremati spearator (razmak ili novi red). Buduci da cemo
                      koristiti string specificne funckije, trebamo string.*/
  red *lista=NULL, *temp;

  *redak='\0'; //pocetna vrijednost retka je nulstring; ekvivalentno smo mogli: redak[0]='\0';
  while(fscanf(in,"%s%c",rijec,&sep)>0){
    redak=(char*)realloc(redak, strlen(redak)+strlen(rijec)+2); //2=1+1 (mjesto za separator i kraj '\0')
    sepstr[0]=sep;
    strcat(rijec,sepstr); /*Ovo je tehnicki razlog zasto smo stavili da rijec ima 32, a ne 31 znak*/
    strcat(redak,rijec);
    if(sep=='\n'){ /*ovo je znak da smo zavrsili s citanjem tog retka*/
      temp=lista;
      lista=malloc(sizeof(red));
      lista->r=redak;
      lista->next=temp;

      /*ponistavanje retka*/
      redak=malloc(1); /*ne smijemo staviti free(redak) jer se taj string jos uvijek koristi!*/
      *redak='\0';
    }
  }

  /*Upisivanje u datoteku out*/
  while((temp=lista)){
    fprintf(out,"%s",temp->r); //ne trebamo ici u novi red jer temp->r sadrzi na kraju '\n'
    free(temp->r); //oslobadjamo dinamicki zauzetu memoriju za redak
    lista=temp->next;
    free(temp); //oslobadjamo dinamicki zauzetu memoriju za cvor temp
  }
}

int main(void){
  FILE*in=fopen("tekstualne_datoteke/redom.txt","rt"), *out=fopen("tekstualne_datoteke/obrnutimredom.txt","wt");
  if(!in||!out)
    return printf("Problem s otvaranjem\n");

  invertiraj(in,out);

  return 0;
}

