/*
Rjesenje nije elegantno, ali ne trebamo koristiti dinamicki
alocirano polje, vec vise puta prolaziti kroz datoteku.
*/

#include <stdio.h>
#include <stdlib.h>

double maxstupac(FILE* in)
{
    int n, i, j, k=0, kmax, prvi=1;
    double x, s=0, smax;

    fscanf(in,"%d",&n);
    if(n<=0)
        exit(1);
    rewind(in);

    while(k<n){
        fscanf(in,"%d",&n); //moramo procitati svaki put i taj prvi broj
        for(i=0; i<n; i++){
            for(j=0; j<n; j++){
                fscanf(in,"%lf",&x);
                if(j==k) //racunamo samo sumu k-tog stupca
                    s+=x;
            }
        }
        printf("Suma %d. stupca je %g.\n", k,s);
        if(prvi || smax<s){
            smax=s;
            kmax=k;
            prvi=0;
        }
        s=0;
        k++;
        rewind(in); //vracamo se na pocetak datoteke
    }

    printf("Indeks je %d\n", kmax);

    return smax;
}

int main(void)
{
    FILE *in;

    if((in=fopen("tekstualne_datoteke/matrica.txt", "rt"))==NULL){
        printf("Greska prilikom otvaranja ulazne datoteke!\n");
        exit(1);
    }

    printf("Rezultat je: %g\n", maxstupac(in));

    fclose(in);

    return 0;
}
